<?php ini_set('max_execution_time', 60*60*30);//ini_set('zlib.output_compression', 'Off');//ini_set('max_input_time', 60*60*11);

	
	include('Mysqldump.php');
	use Ifsnop\Mysqldump as IMysqldump;
	
	
	

	function kbd_cron_process(){
	
		global $kbd_db_prefix;
	
		$kbd_rc = requirements_check();	

		$settings = load_kbd_settings();	

		$default_email = get_bloginfo('admin_email');
		$configEmail = $settings['recpient_email_address'];

		$body = $_SERVER['HTTP_HOST'].' - Database Backup by Wordpress Plugin Keep Backup Daily';
		
		if($configEmail==''){
			$configEmail = $default_email;
			$body .= ' - "You are receiving backups on your Admin Email address." ';
		}
		
		$backup_stats = get_backup_stats();
		$zip_file = $backup_stats['zip_file'];					
		//$subject = 'Database Backup - '.str_replace(array('.zip', '.gz', $kbd_db_prefix), '', basename($zip_file));
		$subject = 'Database Backup - ' . get_bloginfo('name') . ' ' . str_replace(array('.zip', '.gz', $kbd_db_prefix), '', basename($zip_file));
		
		$headers = array();
		$headers[] = 'From: Backup <'.get_bloginfo('admin_email').'>';
		$headers[] = 'Content-Type: text/html; charset=UTF-8';
		
		$wp_mail = false;
		
		$attachments = array($zip_file);
		
		add_filter( 'wp_mail_content_type', 'kbd_email_content_type' );	
		
		if(file_exists($zip_file))
		$wp_mail = wp_mail($configEmail, $subject, $body, $headers, $attachments);
		
		if($wp_mail){
		
			$db_size = formatSizeUnits(filesize($zip_file));
			//unlink($zip_file);
							   

			if($settings['maintain_log']){	

				$string = 'File size: '.$db_size.',  Sent to <a mailto="'.$configEmail.'">'.$configEmail.'</a> at '.date('d M, Y h:i:s a');

				log_kbd($string);

			}					
			
			echo '<span style="color:green">'.strtolower($_SERVER['HTTP_HOST']).'</span>';

		}else{
			echo '<span style="color:red">'.strtoupper($_SERVER['HTTP_HOST']).'</span>';
		}
		
		exit;
	}
    
	function kbd_email_content_type() {
		return 'text/html';
	}
	
	function get_backup_stats($stats_only = false){
		
		
		
		$upload_dir = wp_upload_dir();
		extract($upload_dir);	
		
		$zipfiles = kdb_list_zipfiles($basedir);		
		
		if(empty($zipfiles)){
			kbd_db_backup_process();
			$zipfiles = kdb_list_zipfiles($basedir);		
		}
		
		
		
		$ret =  array();			
		$backup_file = $basedir.'/'.current($zipfiles);
		$ret['zip_file'] = $backup_file;

		return $ret;
	
	}
	
	
	function kbd_db_backup_process(){
		global $kbd_db_prefix;
		
		
		$dumpSettings = array(
			'exclude-tables' => array(),//array('/^travis*/'),
			'compress' => IMysqldump\Mysqldump::GZIP,//IMysqldump\Mysqldump::NONE|GZIP
			'no-data' => false,
			'add-drop-table' => true,
			'single-transaction' => true,
			'lock-tables' => true,
			'add-locks' => true,
			'extended-insert' => false,
			'disable-keys' => true,
			'skip-triggers' => false,
			'add-drop-trigger' => true,
			'routines' => true,
			'databases' => false,
			'add-drop-database' => false,
			'hex-blob' => true,
			'no-create-info' => false,
			'where' => ''
		);
		
		$dump = new IMysqldump\Mysqldump(
			"mysql:host=".DB_HOST.";dbname=".DB_NAME,
			DB_USER,
			DB_PASSWORD,
			$dumpSettings);
		
		//pree($dumpSettings);
		$upload_dir = wp_upload_dir();
		extract($upload_dir);
		

		switch($dumpSettings['compress']){
			default:
				$ext = 'sql';
			break;
			case 'Zip':
			case 'Gzip':
			case 'Bzip2':
				$ext = 'gz';
			break;			
			
		}
		
		$filename = $kbd_db_prefix.date('Y-M-d-H-i').".".$ext;
		$dump_file = $basedir."/".$filename;
		//pree($basedir);exit;
		
		$dump->start($dump_file);		
		exit;
	}
	
	function kdb_list_zipfiles($mydirectory) {
		
		global $kbd_db_prefix;
		
		$ret = array();
		// directory we want to scan
		$dircontents = scandir($mydirectory);
		
		// list the contents
		
		foreach ($dircontents as $file) {
			$extension = pathinfo($file, PATHINFO_EXTENSION);
			if ($extension == 'gz' && strpos($file, $kbd_db_prefix)>=0) {
				
				$t = filemtime($mydirectory.'/'.$file);
				$ret[$t] = $file;
			}
		}
		krsort($ret);
		return $ret;
	}
	
	function kbd_force_download()
	{
			global $kbd_db_prefix, $kbd_backup_url;
			
			
			
				
			$upload_dir = wp_upload_dir();
			extract($upload_dir);	
			
			$zipfiles = kdb_list_zipfiles($basedir);
			
			if(empty($zipfiles) || isset($_GET['fresh'])){
				
				if(!isset($_GET['fresh'])){
					
					echo '<h1>There is no backup exists yet, please wait a little for new backup.</h1>
					<script>setTimeout(function(){ document.location.href="'.$kbd_backup_url.'&fresh"; }, 3000);</script>
					';
					exit;
				}else{			
					echo '<h1>Please wait a little more.</h1>';	
					echo '<script>setTimeout(function(){ document.location.href="'.$kbd_backup_url.'"; }, 3000);</script>';	
					kbd_db_backup_process();
						
				}
				
			}elseif(!isset($_GET['fresh']) && !isset($_GET['file'])){
				
					
					
					echo '<h1>Following database backups are available:</h1>';
					echo '<a style="float:right; margin-right:10px;" href="'.$kbd_backup_url.'&fresh" class="button button-primary">Click here for latest backup</a>';
					echo '<ol class="kbd-bkup-list">';
					$b = 0;
					foreach($zipfiles as $files){ $b++;
						$name = str_replace(array($prefix, '.gz'), '', $files);
						list($year, $month, $day, $h, $i) = explode('-', $name);
						
						$date = $day.' '.$month.', '.$year.' <small>('.$h.':'.$i.')</small>';
						
						$title = kbd_backup_aliases($name);
						
						$title = ($title!=$name?$title:'Database Backup of '.$date);
						
						$file = $kbd_backup_url.'&file='.$name;
						
						
						
						echo '<li>';
						echo '<input type="text" value="'.$title.'" />';
						echo '<a title="Click here to edit this title" class="kbd-bkup-title" data-key="'.$name.'">'.$title.'</a>';
						echo '<a style="margin-left:100px; font-size:12px; color:blue;" href="'.$file.'" target="_blank">Download</a>';
						echo '<a style="margin-left:100px; font-size:12px; color:red;" href="'.$file.'&rm">Delete</a>';
						echo ($b==1?' <span style="margin-left:100px">[LATEST]</span>':'');
						echo '</li>';
					}
					echo '</ol>';					
			}elseif(isset($_GET['file'])){				
				
				$filename = $basedir.'/'.$prefix.$_GET['file'].'.gz';
				
				if(isset($_GET['rm'])){
					if(file_exists($filename))
					unlink($filename);
					
					wp_redirect($kbd_backup_url);
					exit;
				}
				if(isset($_GET['file'])){
					ob_clean();ob_start();
					
					$mime = "application/x-gzip";
					header( "Content-Type: " . $mime );
					header( 'Content-Disposition: attachment; filename="Backup-' . str_replace($kbd_db_prefix,  '', $_GET['file']).'.gz' . '"' );					
					readfile($filename);		
				}
			}
			
			
			exit;
			

			
	}	
	